#!/usr/local/bin/python

import sys
import os
from optparse import OptionParser
from util import init_principal_identities, creddy_assign, simple_options


# Add the credentials to the principal that represent a successful sliver
# creation at an aggregate manager.

opts, args = simple_options().parse_args()

if len(args) >= 2:
    p, am = args[0:2]
else:
    sys.exit("Usage: %s principal aggregate_manager" % sys.argv[0])

init_principal_identities((p, am), opts.debug)

# Make sure that the principal can tell others the identity of the AM doing the
# delegation (knows the AM's public key).
if not os.access('%s/%s_ID.pem' % (p, am), os.F_OK):
    os.link('%s/%s_ID.pem' % (am, am), '%s/%s_ID.pem' % (p, am))

# These are direct assigments from described in the document
creddy_assign(am, 'DeleteSliver_UUID', p, '%s/%s_rule5.der' % (p, am), 
	opts.debug)
creddy_assign(am, 'SliverStatus_UUID', p, '%s/%s_rule6.der' % (p, am),
	opts.debug)
creddy_assign(am, 'RenewSliver_UUID', p, '%s/%s_rule7.der' % (p, am),
	opts.debug)
creddy_assign(am, 'Shutdown_UUID', p, '%s/%s_rule8.der' % (p, am),
	opts.debug)

