#!/usr/local/bin/python

import sys
import os
from optparse import OptionParser
from util import init_principal_identities, creddy_assign, \
	creddy_linking_role, simple_options

# An example of the credential delegation in Section 5.3 of the doc.

opts, args = simple_options().parse_args()

init_principal_identities(('AM', 'CH', 'CH1', 'CH2', 'CH3'), opts.debug)
creddy_linking_role('AM', 'delegate_CreateSliver', 'AM', 
    'delegate_CreateSliver', 'delegate_CreateSliver', 'AM/rule1.der', 
    opts.debug)
creddy_assign('AM', 'delegate_CreateSliver', 'CH', 'AM/rule2.der', opts.debug)
creddy_assign('CH', 'CreateSliver', 'CH', 'CH/rule3.der', opts.debug)
creddy_assign('CH', 'delegate_CreateSliver', 'CH1', 'CH1/rule4.der', opts.debug)
# Make sure CH1 has CH's identity
if not os.access('CH1/CH_ID.pem', os.F_OK):
    os.link('CH/CH_ID.pem', 'CH1/CH_ID.pem')
creddy_assign('CH', 'CreateSliver', 'CH1', 'CH1/rule5.der', opts.debug)
creddy_assign('CH1', 'CreateSliver', 'CH2', 'CH2/rule6.der', opts.debug)
# Make sure CH2 has CH's identity
if not os.access('CH2/CH_ID.pem', os.F_OK):
    os.link('CH/CH_ID.pem', 'CH2/CH_ID.pem')
# Make sure CH2 has CH1's identity
if not os.access('CH2/CH1_ID.pem', os.F_OK):
    os.link('CH1/CH1_ID.pem', 'CH2/CH1_ID.pem')
# Make sure CH2 has CH1's delegation info
if not os.access('CH2/rule4.der', os.F_OK):
    os.link('CH1/rule4.der', 'CH2/rule4.der')
creddy_assign('CH2', 'CreateSliver', 'CH3', 'CH3/rule7.der', opts.debug)
# Make sure CH3 has CH2's identity
if not os.access('CH3/CH2_ID.pem', os.F_OK):
    os.link('CH2/CH2_ID.pem', 'CH3/CH2_ID.pem')
# Make sure CH3 has CH's identity
if not os.access('CH3/CH_ID.pem', os.F_OK):
    os.link('CH/CH_ID.pem', 'CH3/CH_ID.pem')
# Make sure CH3 has CH1's delegation info (this is insufficient, but gives CH3
# some kind of best chance - AM can trace the delegation chain as far as
# possible with it.  A correct delegation would require CH2 to have a
# delegate_CreateSliver attribute and for CH3 to know it).  Again see the
# example.
if not os.access('CH3/rule4.der', os.F_OK):
    os.link('CH1/rule4.der', 'CH3/rule4.der')
creddy_linking_role('AM', 'CreateSliver', 'AM', 
    'delegate_CreateSliver', 'CreateSliver', 'AM/rule8.der', opts.debug)
