#!/usr/local/bin/python

import sys
import os
from optparse import OptionParser
from util import init_principal_identities, creddy_assign, simple_options

# Sign the key of a subordinate clearinghouse (or hierarchically authorize one,
# depending on how you look at things).

opts, args = simple_options().parse_args()

if len(args) >= 2:
    nch, ch = args[0:2]
else:
    sys.exit("Usage: %s new_clearinghouse parent_clearinghouse" % sys.argv[0])

init_principal_identities((nch, ch), opts.debug)
# make sure that the new clearinghouse knows all about delegations of
# clearinghouse authority.
for f in os.listdir(ch):
    if f.endswith('_ID.pem') or f.endswith('_auth.der'):
	if not os.access('%s/%s' % (nch, f), os.F_OK):
	    os.link('%s/%s' % (ch, f), '%s/%s' % (nch, f))

# This is the delegation to this clearinghouse
creddy_assign(ch, 'clearinghouse', nch, '%s/%s_auth.der' % (nch, ch), 
	opts.debug)

