#!/usr/local/bin/python

import sys
import os
from optparse import OptionParser
from util import init_principal_identities, creddy_assign, simple_options

# Get the basic credentials from a clearinghouse for a principal.  Very
# directly from the document.

opts, args = simple_options().parse_args()

if len(args) >= 2:
    p, ch = args[0:2]
else:
    sys.exit("Usage: %s principal clearinghouse" % sys.argv[0])

init_principal_identities((p, ch), opts.debug)

# make sure that the principal knows all about delegations of clearinghouse
# authority.
for f in os.listdir(ch):
    if f.endswith('_ID.pem') or f.endswith('_auth.der'):
	if not os.access('%s/%s' % (p, f), os.F_OK):
	    os.link('%s/%s' % (ch, f), '%s/%s' % (p, f))

# Direct assignments
creddy_assign(ch, 'GetCredential', p, '%s/rule1.der' % p, opts.debug)
creddy_assign(ch, 'Register_user_UUID', p, '%s/rule2.der' % p, opts.debug)
creddy_assign(ch, 'Register_slice', p, '%s/rule3.der' % p, opts.debug)
creddy_assign(ch, 'Resolve', p, '%s/rule4.der' % p, opts.debug)
creddy_assign(ch, 'ListComponents', p, '%s/rule5.der' % p, opts.debug)

