#!/usr/local/bin/python

import sys
import os
from optparse import OptionParser
from util import init_principal_identities, creddy_assign, simple_options

# Give the principal the credentials that result from a successful slice
# registration at the slice authority.

opts, args = simple_options().parse_args()

if len(args) >= 2:
    p, sa = args[0:2]
else:
    sys.exit("Usage: %s principal slice_authority" % sys.argv[0])

init_principal_identities((p, sa), opts.debug)
# Make sure the principal knows the SA's identity
if not os.access('%s/%s_ID.pem' % (p, sa), os.F_OK):
    os.link('%s/%s_ID.pem' % (sa, sa), '%s/%s_ID.pem' % (p, sa))

# Direct assignments
creddy_assign(sa, 'GetCredential_UUID', p, '%s/%s_rule8.der' % (p, sa), 
	opts.debug)
creddy_assign(sa, 'Remove_UUID', p, '%s/%s_rule9.der' % (p, sa), opts.debug)
creddy_assign(sa, 'Bind_UUID', p, '%s/%s_rule10.der' % (p, sa), opts.debug)
creddy_assign(sa, 'Renew_UUID', p, '%s/%s_rule11.der' % (p, sa), opts.debug)
creddy_assign(sa, 'Shutdown_UUID', p, '%s/%s_rule12.der' % (p, sa), opts.debug)
creddy_assign(sa, 'CreateSliver', p, '%s/%s_rule13.der' % (p, sa), opts.debug)

